/*global Faye */
if (window.Transistor === undefined) {
    window.Transistor = {};
}

(function (transistor) {

    var Radio = (function () {

        return function (aerial_url, station_uid, token, cache) {
            var radio = this,
                faye,
                H,
                Extension;

            H = (function () {
                var callbacks = {},
                    buildChannel;

                buildChannel = function (channel_path) {
                    return ['', station_uid, token, channel_path].join('/');
                };

                return {
                    registerCallback: function (channel_path, callback) {
                        var channel = buildChannel(channel_path),
                            listener = function (message) {
                                callback(message.event, message.args);
                            };

                        callbacks[channel_path] = listener;

                        faye.subscribe(channel, listener);
                    },
                    triggerCallback: function (channel_path, message) {
                        callbacks[channel_path](message);
                    }
                };
            }());

            Extension = (function () {
                var process = function (message, callback) {
                    if (message.ext && message.ext.init) {
                        var channel_path = message.subscription.split('/').splice(3).join('/');
                        H.triggerCallback(channel_path, {
                            event: 'init',
                            args: message.ext.init.collection
                        });
                    }
                    callback(message);
                };

                return function () {
                    this.incoming = process;
                };
            }());

            faye = new Faye.Client(aerial_url);
            faye.addExtension(new Extension());

            radio.tune = function (channel_path, callback) {
                H.registerCallback(channel_path, callback);
            };

            return radio;
        };
    }());

    transistor.Radio = Radio;

}(window.Transistor));
